#!/usr/bin/env python
#^#
#
# <description>
#
#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

import sys
import logging
from OVSLog import init_log
from OVSConstants import COMPAT_PYTHON_LIB, COMPAT_SBIN, COMPAT_LIB
from OVSCommons import fmt_err_msg

init_log("client")
logger = logging.getLogger()
try:
    #libvirt
    _path = os.environ.get("LD_LIBRARY_PATH")
    if not _path:
        os.environ["LD_LIBRARY_PATH"] = COMPAT_LIB
    else:
        os.environ["LD_LIBRARY_PATH"] = "%s:%s" % (COMPAT_LIB, _path)

    #virtinst
    _path = os.environ.get("PYTHONPATH")
    if not _path:
        os.environ["PYTHONPATH"] = COMPAT_PYTHON_LIB
    else:
        os.environ["PYTHONPATH"] = "%s:%s" % (COMPAT_PYTHON_LIB, _path)
    #change internal PYTHONPATH
    if sys.path[0] != COMPAT_PYTHON_LIB:
        sys.path.insert(0, COMPAT_PYTHON_LIB)
    logger.info("OVSCompat: success. sys.path=%s" % repr(sys.path))
    import virtinst

    #virt-install
    if not os.environ["PATH"].startswith(COMPAT_SBIN):
        os.environ["PATH"] = "%s:%s" % (COMPAT_SBIN, os.environ["PATH"])
    logger.info("OVSCompat: success. PATH=%s" % os.environ["PATH"])

except Exception, e:
    errmsg = fmt_err_msg(e)
    logger.error("OVSCompat: error. => %s" % errmsg)
