#!/usr/bin/env python

#^#
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

#hierarchical error code
ERR_GENERAL = (0,)
ERR_SERVER_SELECTION = (0, 1, )

class OVSException(Exception):
    def __init__(self, errmsg="", errcode=ERR_GENERAL):
        self.errmsg = errmsg
        self.errcode = errcode

    def __str__(self):
        return self.errmsg

    def is_kind_of(self, err):
        if isinstance(err, OVSException):
            err = err.errcode
        if not isinstance(err, (list, tuple)):
            return False
        if len(err) > len(self.errcode):
            return False
        for idx, e in enumerate(err):
            if self.errcode[idx] != e:
                return False
        return True

