#!/usr/bin/env python
#^#
# OVSServerProxy.py
#
# <description>
#
#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#
import xmlrpclib
from OVSConfig import get_config
from OVSAsyncTaskAux import in_asyncenv, AsyncenvAgentcallProxy

class ServerProxy(object):
    def __init__(self, p):
#        config = get_config()
#        if config.get("security", "ssl").lower().startswith("enable"):
#            protocol = "https://"
#        else:
#            protocol = "http://"

        if isinstance(p, dict):
            if "ip" in p:
                agt_addr = p["ip"]
            elif "agt_addr" in p:
                agt_addr = p["agt_addr"]
            else:
                raise Exception("No attribute 'ip' or 'agt_addr' in dict.")

            for key in ("agt_username", "agt_passwd", "agt_port"):
                if key not in p:
                    raise Exception("attr '%s' is mandatory." % key)
                elif not p[key].strip():
                    raise Exception("attr '%s' must not be empty." % key)
            if "ssl_enabled" in p and p["ssl_enabled"]:
                protocol = "https://"
            else:
                protocol = "http://"

            agt_url = "%s%s:%s@%s:%d" % \
                    (protocol, p["agt_username"], p["agt_passwd"], agt_addr, p["agt_port"])

        elif isinstance(p, str):
            #agt_url = p.replace(protocol, "http://")
            agt_url = p
        else:
            raise Exception("%s is not of type dict or str!" % repr(p))

        self._sp = xmlrpclib.ServerProxy(agt_url)
        self.agt_url = agt_url

    def __getattr__(self, name):
        if not in_asyncenv():
            return getattr(self._sp, name)
        else:
            return getattr(AsyncenvAgentcallProxy(self._sp, name), name)
