#!/usr/bin/env python
#^#
# db_del.py
#
# <description>
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

from os.path import dirname, join
import sys
sys.path.append(join(dirname(__file__), ".."))

from bsddb import dbshelve
from OVSConstants import CONFIG_DIR

if len(sys.argv) < 2 or len(sys.argv) > 3:
    print "%s <db> <key>" % sys.argv[0]
    sys.exit(1)

if len(sys.argv) == 2: 
    sys.argv.append("")

db_name, keyword = sys.argv[1:]
if not db_name.endswith(".db"):
    db_name = "%s.db" % db_name
db_name = join(CONFIG_DIR, "db/%s" % db_name)
db = dbshelve.open(db_name)

candidates = [k for k in db.keys() if keyword in k]
if not candidates:
    print "no candidates."
else:
    print "these records will be removed:"
    for n, key in enumerate(candidates):
	print "%d) %s" % (n, key)
    answer = raw_input("which one to remove? ('Y' to remove all)")
    if answer.lower() in ("y", "yes", "sure", "ok"):
        for n, key in enumerate(candidates): 
            del db[key]
            print "removed %d) %s" % (n, key)
    else:
        ns = answer.lower().split()
        for n in ns:
            try:
                n = int(n)
                key = candidates[n]
                del db[key]
                print "removed %d) %s" % (n, key)
            except: pass

print   
db.close()
