#!/usr/bin/env python
#^#
# db_kfv.py
#
# <description>
#
#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#

from os.path import dirname, join
import sys
sys.path.append(join(dirname(__file__), ".."))

from bsddb import dbshelve
from OVSConstants import CONFIG_DIR

def value_of(x):
    for func in (int, float, str):
        try:
            rs = func(x)
            return rs
        except: pass

i = len(sys.argv)
if i == 1:
    print "more arguments needed...\n"
    sys.exit(1)
while i < 5:
    i += 1
    sys.argv.append(None)

db_name, key, field, value = sys.argv[1:]
if not db_name.endswith(".db"):
    db_name = "%s.db" % db_name
db_name = join(CONFIG_DIR, "db/%s" % db_name)
db = dbshelve.open(db_name)
for k, rec in db.items():
    if key in k:
        if field in rec:
            print "%s \t%s(now)=>%s" % (k, field, rec[field])
            if value or isinstance(value, str):
                rec[field] = value_of(value)
                db[k] = rec
                print "%s \t%s(new)=>%s" % (k, field, rec[field])
db.close()
