# Copyright (C) 2008, Oracle
#!/usr/bin/env python
# pm_wol.py
# OracleVM 2.1.2
# Wake-On-LAN

import socket
import struct

def pm_wol(mac_addr, password=None):
    """ Switches on remote computers using WOL. """
    print "password",password

    # Check mac_addr format and try to compensate.
    if len(mac_addr) == 12:
        pass
    elif len(mac_addr) == 12 + 5:
        sep = mac_addr[2]
        mac_addr = mac_addr.replace(sep, '')
    else:
        raise ValueError('Incorrect MAC address format')
 
    # Pad the synchronization stream.
    data = ''.join(['FFFFFFFFFFFF', mac_addr * 16])
    send_data = '' 

    # Split up the hex values and pack.
    for i in range(0, len(data), 2):
        send_data = ''.join([send_data, struct.pack('B', int(data[i: i + 2], 16))])

    if password:
        password_len = len(password)
        if password_len > 6:
            password_len = 6
        for i in range(0, password_len, 2):
            send_data = ''.join([send_data, struct.pack('B', int(password[i : i + 2], 16))])

    # Broadcast it to the LAN.
    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    sock.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
    sock.sendto(send_data, ('<broadcast>', 7))
    

if __name__ == '__main__':
    # Use mac_addres with any seperators.
    tz1_mac = '00:18:8B:10:10:6B'
    tz2_mac = '00:19:B9:0D:02:02'
    pm_wol(tz2_mac)
    # or without any seperators.
