#!/usr/bin/env python
#^#
# netcfg.py
#
# inside a vm, we pass ifconfig parameters throu kernel cmdline
# (/proc/cmdline). then configure network accordingly.
#
# 
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#
import zlib
import sys
import os
from os.path import exists

def config_network(ifcfgs):
    updated = False
    for (dev, cfg) in ifcfgs.items():
	ifcfg = "DEVICE=%s\nONBOOT=yes\n" % dev
	if cfg["inet_type"].upper() == "DHCP":
            ifcfg += "BOOTPROTO=dhcp\n"
	elif cfg["inet_type"].upper() == "STATIC":
	    ifcfg += """BOOTPROTO=static\n
	    IPADDR=%s\n
	    NETMASK=%s\n
	    GATEWAY=%s\n""" % (cfg["ip"], cfg["netmask"], cfg["gateway"])

        cfg_file = "/etc/sysconfig/network-scripts/ifcfg-%s" % dev
	if exists(cfg_file):
	    f = open(cfg_file, "r")
	    ifcfg_old = f.read()
	    f.close()
	else: ifcfg_old = ""
        if ifcfg_old != ifcfg:
            updated = True
	    f = open(cfg_file, "w"); f.write(ifcfg); f.close()
	    os.system("/sbin/ifdown %s; /sbin/ifup %s" % (dev, dev))

    return updated
    
def main():
    f = open("/proc/cmdline"); cmdline = f.read(); f.close()
    #cmdline = "ifcfgs=eydldGgwJzogeydpbmV0X3R5cGUnOiAnZGhjcCd9fQ=="
    ifcfgs = None
    for part in cmdline.split(" "):
	if part.startswith("ifcfgs="):
	    ifcfgs = eval(zlib.decompress(part[7:].decode("base64")))
	    break
    if ifcfgs: 
	rs = config_network(ifcfgs)
	if rs: sys.exit(0)
    #if nothing modified, exit 1
    sys.exit(1)

if __name__ == "__main__":
    main()

