#!/usr/bin/env python
#^#
#
# call a agent throu cmd line, usage:
#       do_rpc.py <agent_url> <operation> <argv argv ...>  e.g.
#       do_rpc.py http://oracle:orac1e@ovs-y.cn.oracle.com:8899 echo 'hello world!'
#
#
# Copyright (C) 2006, 2007 Oracle.  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation, version 2.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 021110-1307, USA.
#$#
from os.path import dirname, join
import sys
sys.path.append(join(dirname(__file__), ".."))

import xmlrpclib
import sys
import socket
import re
from ConfigParser import ConfigParser
from OVSConstants import CONFIG_DIR

def main():
    if not re.match(r"https?://(oracle|admin):.+@.+:[0-9]+", sys.argv[1]):
        config = ConfigParser()
        config.read(join(CONFIG_DIR, "agent.ini"))
        admin_username = "admin"
        admin_passwd = config.get("security", "admin.password")
        if config.get("security", "ssl").lower().startswith("enable"):
            protocol = "https"
        else: protocol = "http"
        agt_url="%s://%s:%s@%s:%s" % \
            (protocol, admin_username, admin_passwd, "127.0.0.1", config.get("agent", "port"))
        sys.argv.insert(1, agt_url)

    agt_url = sys.argv[1]
    func = sys.argv[2]
    args = sys.argv[3:]

    server = xmlrpclib.ServerProxy(agt_url)
    server_func_args = [
        ##(server, function_name, parameter_list ),
        (server, func, args),
        ]

    for server, func, args in server_func_args:
        try:
            print "%s %s =>" % (func, args)
            rs = getattr(server, func)(*args)
            print "%s" % rs
            if rs.startswith("failed"):
                sys.exit(1)
        except xmlrpclib.Fault, e:
            print e.faultCode, e.faultString
        except xmlrpclib.ProtocolError, e:
            print e #(url, errcode, errmsg, headers)
        except socket.error, (code, msg):
            print "socket error! code=%s, msg=%s" % (code, msg)
        except SystemExit:
            raise
        except Exception, e:
            print e.__class__, e

if __name__ == "__main__":
    main()

