#!/usr/bin/env python
# Copyright (C) 2008, Oracle
# v2v_status.py
# OracleVM 2.1.2
# V2V status utilities

from OVSCDS import CDS

def get_status(pid):
    if type(pid) == type(0):
        pid = '%d' % pid
    status = ''
    cds = CDS('LOCK_SH', 'v2vstatus%s' % pid)
    try:
        if pid in eval('cds.db_v2vstatus%s' % pid):
            status = eval('cds.db_v2vstatus%s[pid]' % pid)
    finally:
        cds.close()
    return status

def set_status(pid, status):
    if type(pid) == type(0):
        pid = '%d' % pid

    # save the first line if it's multi-line
    if status.find('\n') != -1:
        status = status.split('\n')[0]

    cds = CDS('v2vstatus%s' % pid)
    try:
        db = eval('cds.db_v2vstatus%s' % pid)
        db[pid] = status
    finally:
        cds.close()

def save_utl_srv(pid, hostname):
    if type(pid) == type(0):
        pid = '%d' % pid
    cds = CDS('v2vutlsrv%s' % pid)
    try:
        db = eval('cds.db_v2vutlsrv%s' % pid)
        db[pid] = hostname
    finally:
        cds.close()

def get_utl_srv(pid):
    if type(pid) == type(0):
        pid = '%d' % pid
    hostname = None
    cds = CDS('LOCK_SH', 'v2vutlsrv%s' % pid)
    try:
        if pid in eval('cds.db_v2vutlsrv%s' % pid):
            hostname  = eval('cds.db_v2vutlsrv%s[pid]' % pid)
    finally:
        cds.close()
    return hostname

if __name__ == '__main__':
    set_status('123456', 'process status')
    print get_status('123456')
    save_utl_srv('123456', 'test hostname')
    print get_utl_srv('123456')


